/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.batch.commonj.transaction;

import jp.terasoluna.fw.dao.UpdateDAO;
import jp.terasoluna.fw.batch.jobmessage.JobMessageInfo;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.jdbc.UncategorizedSQLException;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.TransactionStatus;

/**
 * Wusʃe[uɓo^nhB<br>
 * 
 * 
 */
public class JobResultInfoHandlerImpl implements JobResultInfoHandler {

    /**
     * OCX^XB
     */
    private static Log log = LogFactory.getLog(
                JobResultInfoHandlerImpl.class);

    /**
     * UPDATEpDAOB SpringDI@\pĐݒ肷B
     */
    private UpdateDAO updateDAO = null;

    /**
     * gUNV}l[WB
     */
    private PlatformTransactionManager transactionManager = null;

    /**
     * WusǗ֓o^SQLIDB
     */
    private static final String INSERT_JOB_RESULT 
            = "jobResult.INSERT_JOB_RESULT";

    /**
     * JOB_RESULTe[uɃWu̎sʂo^B
     * 
     * @param jobMessageInfo WuǗ
     * @return o^
     */
    public int handle(JobMessageInfo jobMessageInfo) {
        if (log.isDebugEnabled()) {
            log.debug("Job Result Handler [regist] transaction start...");
        }
        int count = 0;
        TransactionStatus transactionStatus = transactionManager
                .getTransaction(null);
        try {
            count = updateDAO.execute(INSERT_JOB_RESULT, jobMessageInfo);
            if (!transactionStatus.isCompleted()) {
                transactionManager.commit(transactionStatus);
                if (log.isDebugEnabled()) {
                    log.debug(
                            "Job Result Handler [regist] transaction commit.");
                }
            }
        } catch (UncategorizedSQLException e) {
            if (!transactionStatus.isCompleted()) {
                transactionManager.rollback(transactionStatus);
            }
            log.error(e.getMessage());
        }
        return count;
    }

    /**
     * UPDATEpDAOB
     * 
     * @param updateDAO UPDATEpDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }

    /**
     * gUNV}l[WB
     * 
     * @param transactionManager gUNV}l[W
     */
    public void setTransactionManager(
            PlatformTransactionManager transactionManager) {
        this.transactionManager = transactionManager;
    }

}
