/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.batch.jobmessage;

import java.util.Date;

import jp.terasoluna.fw.batch.init.JobControlInfo;

/**
 * Wu˗bZ[WǗe[ũp[^NXB
 * 
 * 
 */
public class JobMessageInfo extends JobControlInfo {

    /**
     * Serializablepo[WIDB
     */
    private static final long serialVersionUID = -2755193066158860641L;

    /**
     * AWup[^B
     */
    private String jobConcatParameters;

    /**
     * p[eBVNoB
     */
    private int partitionNo = -1;

    /**
     * p[eBVL[B
     */
    private String partitionKey = null;

    /**
     * bZ[WM󋵁B
     */
    private String messageState;

    /**
     * bZ[WMB
     */
    private Date receiveTime;

    /**
     * bZ[WMB
     */
    private Date sendTime;

    /**
     * WuIԁB
     */
    private Date finishTime;

    /**
     * bZ[WM󋵂̎擾B
     * 
     * @return bZ[WM
     */
    public String getMessageState() {
        return messageState;
    }

    /**
     * bZ[WM󋵂̐ݒB
     * 
     * @param messageState bZ[WM
     */
    public void setMessageState(String messageState) {
        this.messageState = messageState;
    }

    /**
     * bZ[WM̎擾B
     * 
     * @return bZ[WM
     */
    public Date getReceiveTime() {
        return receiveTime;
    }

    /**
     * bZ[WM̐ݒB
     * 
     * @param receiveTime bZ[WM
     */
    public void setReceiveTime(Date receiveTime) {
        this.receiveTime = receiveTime;
    }

    /**
     * bZ[WM̎擾B
     * 
     * @return bZ[WM
     */
    public Date getSendTime() {
        return sendTime;
    }

    /**
     * bZ[WM̐ݒB
     * 
     * @param sendTime bZ[WM
     */
    public void setSendTime(Date sendTime) {
        this.sendTime = sendTime;
    }

    /**
     * AWup[^̎擾B
     * 
     * @return jobConcatParameters AWup[^
     */
    public String getJobConcatParameters() {
        return jobConcatParameters;
    }

    /**
     * AWup[^̐ݒB
     * 
     * @param jobConcatParameters AWup[^
     */
    public void setJobConcatParameters(String jobConcatParameters) {
        this.jobConcatParameters = jobConcatParameters;
        super.setJobParameters(jobConcatParameters);
    }

    /**
     * Wup[^̐ݒB
     * 
     * @param jobParameters Wup[^
     */
    @Override
    public void setJobParameters(String jobParameters) {
        setJobConcatParameters(jobParameters);
    }

    /**
     * WuIԂ̎擾B
     * 
     * @return WuI
     */
    public Date getFinishTime() {
        return finishTime;
    }

    /**
     * WuIԂ̐ݒB
     * 
     * @param finishTime WuI
     */
    public void setFinishTime(Date finishTime) {
        this.finishTime = finishTime;
    }

    /**
     * p[eBVL[擾B
     * 
     * @return partitionKey p[eBVL[
     */
    public String getPartitionKey() {
        return partitionKey;
    }

    /**
     * p[eBVL[ݒ肷B
     * 
     * @param partitionKey p[eBVL[
     */
    public void setPartitionKey(String partitionKey) {
        this.partitionKey = partitionKey;
    }

    /**
     * p[eBVNO擾B
     * 
     * @return partitionNo p[eBVNO
     */
    public int getPartitionNo() {
        return partitionNo;
    }

    /**
     * p[eBVNOݒ肷B
     * 
     * @param partitionNo p[eBVNO
     */
    public void setPartitionNo(int partitionNo) {
        this.partitionNo = partitionNo;
    }
}
