/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.batch.standard;

import java.util.List;

import jp.terasoluna.fw.batch.core.AbstractCollector;
import jp.terasoluna.fw.batch.core.CollectedDataHandler;
import jp.terasoluna.fw.batch.core.CollectorResult;
import jp.terasoluna.fw.batch.core.JobStatus;
import jp.terasoluna.fw.batch.openapi.JobContext;
import jp.terasoluna.fw.batch.openapi.ReturnCode;


/**
 * ɐݒ肳ꂽXgA擾sRN^B
 * 
 * <p>Spring̒`t@CŁA擾f[^̃RN^̑lƂăCWFN
 * VĎgƂłB</p>
 * <p>Bean`t@CɃvpeBݒ肪݂Ȃꍇɂ͗OƂď
 * B</p>
 * 
 */
public class ListPropertyCollector extends AbstractCollector {

    /**
     * 擾Ώۂ̃XgB
     */
    private List<Object> dataList = null;
    
    /**
     * 擾Ώۂ̃Xgݒ肷B
     * 
     * @param dataList 擾Ώۂ̃Xg
     */
    public void setDataList(List<Object> dataList) {
        this.dataList = dataList;
    }

    /**
     * 擾sB
     * 
     * <p>擾Ώۂ̃Xgf[^擾B</p>
     * 
     * @param jobContext WuReNXg
     * @param collectedDataHandler 擾f[^nh
     * @param jobStatus WuXe[^X
     * @return 擾
     */
    @Override
    protected CollectorResult doCollect(JobContext jobContext, 
            CollectedDataHandler collectedDataHandler, JobStatus jobStatus) {
        int collected = 0;
        for (Object listItem : dataList) {
            collectedDataHandler.handle(listItem, collected++);
            jobStatus.incrementCollected();
        }
        return new CollectorResult(ReturnCode.NORMAL_END, collected);
    }
}
