/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.batch.standard;

import java.util.LinkedHashMap;

import jp.terasoluna.fw.batch.core.ExceptionHandlerUtil;
import jp.terasoluna.fw.batch.core.JobException;
import jp.terasoluna.fw.batch.core.JobExceptionHandler;
import jp.terasoluna.fw.batch.core.JobStatus;
import jp.terasoluna.fw.batch.core.WorkQueue;

/**
 * L[vZbT}`XbhŎs邽߂̃bp[NXB
 *
 */
public class RunnableQueueProcessor implements Runnable {

    /**
     * L[vZbTB
     */
    private QueueProcessor queueProcessor;

    /**
     * Ώi[L[B
     */
    private WorkQueue workQueue;

    /**
     * WuXe[^XB
     */
    private JobStatus jobStatus;

    /**
     * Onhi[MapB
     */
    private LinkedHashMap<JobException, JobExceptionHandler> 
        exceptionHandlerMap;

    /**
     * ftHgOnhB
     */
    private JobExceptionHandler defaultJobExceptionHandler;

    /**
     * RXgN^B
     * 
     * <p>œnꂽCX^Xݒ肷B</p>
     *
     * @param queueProcessor L[vZbT
     * @param workQueue [NL[
     * @param jobStatus WuXe[^X
     * @param exceptionHandlerMap Onhi[Map
     * @param defaultJobExceptionHandler ftHgOnh
     */
    public RunnableQueueProcessor(
            QueueProcessor queueProcessor,
            WorkQueue workQueue,
            JobStatus jobStatus,
            LinkedHashMap<JobException, JobExceptionHandler> 
                exceptionHandlerMap,
            JobExceptionHandler defaultJobExceptionHandler) {
        this.queueProcessor = queueProcessor;
        this.workQueue = workQueue;
        this.jobStatus = jobStatus;
        this.exceptionHandlerMap = exceptionHandlerMap;
        this.defaultJobExceptionHandler = defaultJobExceptionHandler;
    }

    /**
     * L[vZbTNB
     *
     */
    public void run() {
        try {
            queueProcessor.process(workQueue, jobStatus);
        } catch (Exception e) {
            // BLogicABLogicʃnhŔȌ
            JobException jobException = new JobException(e);

            JobExceptionHandler handler
                = ExceptionHandlerUtil.getJobExceptionHandler(jobException,
                                                            exceptionHandlerMap,
                                                    defaultJobExceptionHandler);
            handler.handlException(null, jobException, jobStatus);
        }
    }
}
